/*
 Functions.H - Main 128Gamma Functions File

*/

//--------------------------------------------------------------------

//////////////////////////////////////////////////////////////////////

void Error(char *Message)
{
	KillFlag = 1;
	MessageBox(GetActiveWindow(), Message ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL + MB_TASKMODAL);
	CleanUp(1,1);
}

//////////////////////////////////////////////////////////////////////

int CleanUp(int Kill, int Delete)
{
	if(Delete)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		unlink(CompressTemp);
		unlink(PackTemp);
	}

	if(Kill)
	{
		_fcloseall(); //Attempt To Close All Open Files... (If Any)
		sleep(500); // Hopfully Give Time For Files To Flush.
		unlink(CompressTemp);
		unlink(PackTemp);
		exit(0);
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////

int PreCheckFile(char *FileToCheck)
{
	FILE * FileToCheck_File;
	unsigned int Attrib = 0;
	char xDrive[255], xDir[255], xFile[255], xExt[255];
	_splitpath(FileToCheck,xDrive,xDir,xFile,xExt);

	/* Get Input File Attributes */
	Attrib = GetFileAttributes(GlobalFileName);

	/* Check For File Access */
	if(!FAccess(FileToCheck,0)) // Check Exist
		Error("File Does Not Exist. Error 9.");
	if(!FAccess(FileToCheck,4)) // Check Read Access
		Error("File Does Not Allow Read Access. Error 11.");

	if(Attrib & FILE_ATTRIBUTE_DIRECTORY) // If Input Is A Folder
	{
		/* If Directory Name Is 3 Char Long  ( c:\ d:\ ...Etc ) */
		if(strlen(FileToCheck) == 3)
		{
			char MessageTemp[257];
			sprintf(MessageTemp,"128Gamma %s Does Not Have Support For Full Drives At This Time.",ShortVersion);
			MessageBox(GetActiveWindow(),MessageTemp,TitleCaption,+ MB_SYSTEMMODAL);
			return 0;
		}
		return 1;
	}

	DWORD FileSize_Temp = FileSize(FileToCheck);
	if(FileSize_Temp == -1)return 0;

	if(FileSize_Temp > MaxFileSize)
	{
		char MessageTemp[257];
		sprintf(MessageTemp,"128Gamma %s Requires That Files Be Under %d MB",ShortVersion,MaxFileSize/1024/1024);
		MessageBox(GetActiveWindow(),MessageTemp,TitleCaption,+ MB_SYSTEMMODAL);
		return 0;
	}

	if(FileSize_Temp < 1)
	{
		char MessageTemp[257];
		sprintf(MessageTemp,"128Gamma %s Requires That Files Contain Some Data.",ShortVersion);
		MessageBox(GetActiveWindow(),MessageTemp,TitleCaption,+ MB_SYSTEMMODAL);
		return 0;
	}

	/* Open Source File */
	if((FileToCheck_File = fopen(FileToCheck,"rb")) == NULL)
		Error("Could Not Open Source For Read. Error: 13.");

	/* Read File Flag ( If Any ) */
	fread(Buffer,sizeof(char),FlagLEN,FileToCheck_File);

	if(strcmp(Buffer,ENCFlag) == 0) // If File Encryted
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 2;
	}

	if(strcmp(Buffer,PACFlag) == 0) // If File Packed
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 3;
	}

	if(strcmp(Buffer,ENCCompress) == 0) // If File Compressed Encryted
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 4;
	}

	if(strcmp(Buffer,PACCompress) == 0) // If File Compressed Packed
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 5;
	}

	if(strcmp(Buffer,ABIFlag) == 0) // If Encryted By ABI-Coder
	{
		if(FileToCheck_File)
			fclose(FileToCheck_File);
		return 6;
	}

	if(FileToCheck_File)
		fclose(FileToCheck_File);
	return 7; // If File Not Encrypted
}

//////////////////////////////////////////////////////////////////////

int SetTempVariables(void)
{
	sprintf(PackTemp,"%s\\%s",GetTempDirectory(),"Pack.128G");
	sprintf(CompressTemp,"%s\\%s",GetTempDirectory(),"Compress.128G");

	if(!CompressTemp)
		return 1;
	if(!PackTemp)
		return 1;

	return 0;
}

//////////////////////////////////////////////////////////////////////

char *GetTempDirectory(void)
{
	static char StrFunction [64][257] = {'\0'};
	int StrCnt = 0;
	char T[257] = {'\0'};
	GetTempPath (256,T);
	if (++StrCnt==64) StrCnt = 0;
	sprintf(StrFunction[StrCnt],"%s",T);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

void SetText (HWND hDlg, char *Txt)
{
	SendMessage(hDlg,(UINT)WM_SETTEXT,(WPARAM)0,(LPARAM)Txt);
}

/////////////////////////////////////////////////////////////////////

char *GetText (HWND hDlg)
{
	int StrCnt = 0;
	int T = 0;
	char xBuffer[2048] = {'\0'};
	LPSTR StrFunc[16] = {'\0'};
	if (++StrCnt==16) StrCnt = 0;
	if (StrFunc[StrCnt]) free (StrFunc[StrCnt]);
	StrFunc[StrCnt] = (char*) malloc (2048);
	memset (StrFunc[StrCnt],0,2048);
	T=GetWindowTextLength(hDlg);
	GetWindowText(hDlg,xBuffer,T+1);
	sprintf(StrFunc[StrCnt],"%s",xBuffer);
	return StrFunc[StrCnt];
}
/////////////////////////////////////////////////////////////////////

void CenterWindow (HWND hWnd)
{
	static RECT wRect;
	DWORD x = 0;
	DWORD y = 0;
	GetWindowRect(hWnd,&wRect);
	x=(GetSystemMetrics(SM_CXSCREEN)-(wRect.right-wRect.left))/2;
	y=(GetSystemMetrics(SM_CYSCREEN)-(wRect.bottom-wRect.top+GetSystemMetrics(SM_CYCAPTION)))/2;
	SetWindowPos(hWnd,NULL,x,y,0,0,SWP_NOSIZE|SWP_NOZORDER);
}

/////////////////////////////////////////////////////////////////////

int ProcessInput(char *xInput)
{
	short ENCMethod = 0;

	if(strlen(xInput) > 0) // If Any Program Input Params
	{
		sprintf(GlobalFileName,"%s",xInput);

		/*
		0 = Cancel , Dir = 1 , Encrypted = 2 , Packed = 3
		Compressed Encrypted = 4 , Compressed Packed = 5
		ABI-Coder File = 6, Not Encrypted = 7
		*/

		ENCMethod = PreCheckFile(GlobalFileName);

		if(ENCMethod == 0) // Cancel
			return 0;

		if(ENCMethod == 1) // Directory
		{
			Pack = TRUE; // Encrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 2) // Encrypted
		{
			Decrypt = TRUE; // Decrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 3) //  Packed
		{
			Unpack = TRUE; // Unpack File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 4) //  Compressed Encrypted
		{
			DecompressDecrypt = TRUE; // Decompress Decrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 5) //  Compressed Packed
		{
			DecompressUnpack = TRUE; // Decompress Unpack File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 6) // Encrypted by ABI-Coder
		{
			Decrypt = TRUE;   // Decrypt File Flag
			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}

		if(ENCMethod == 7) // NOT Encrypted
		{
			Encrypt = TRUE; // Encrypt File Flag

			DialogBox(hInstance,MAKEINTRESOURCE(100),0,PasswordDialog);
			CleanUp(0,1);
			return(0);
		}
	}

	CleanUp(0,1);

	return 1;
}

/////////////////////////////////////////////////////////////////////

DWORD FileSize(char *File2Size)
{
	FILE *Source;
	DWORD size;
	Source = CreateFile(File2Size,GENERIC_READ,0,NULL,OPEN_EXISTING,0,NULL);
	size = GetFileSize(Source,NULL);
	if(size == HFILE_ERROR)
	{
		char StatusTemp[1024];
		sprintf(StatusTemp,"Cannot Read: \r\n%s \r\nThe File May Be In Use. Error 14.",File2Size);
		MessageBox(StatusDialog_hWnd, StatusTemp ,TitleCaption,0 + MB_SYSTEMMODAL);
		return -1;
	}
	CloseHandle(Source);
	return size;
}

///////////////////////////////////////////////////////////////////////

void ClearBuffer(void)
{
	int LocalLoop;
	LocalLoop = 0;
	while(LocalLoop < sizeof(Buffer))
	{
		Buffer[LocalLoop] = '\0';
		LocalLoop++;
	}
}

///////////////////////////////////////////////////////////////////////

DWORD WINAPI StatusDialog_Thread(LPVOID data)
{
	DialogBox(hInstance,MAKEINTRESOURCE(200),0,StatusDialog);
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI EncryptProcess_Thread(LPVOID data)
{
	EncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI DecryptProcess_Thread(LPVOID data)
{
	DecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI PackProcess_Thread(LPVOID data)
{
	PackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI UnpackProcess_Thread(LPVOID data)
{
	UnpackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI CompressEncryptProcess_Thread(LPVOID data)
{
	CompressEncryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI DecompressDecryptProcess_Thread(LPVOID data)
{
	DecompressDecryptProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI CompressPackProcess_Thread(LPVOID data)
{
	CompressPackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

DWORD WINAPI DecompressUnpackProcess_Thread(LPVOID data)
{
	DecompressUnpackProcess();
	return ((DWORD)data);
}

/////////////////////////////////////////////////////////////////////

char *Get_Time()
{
	static SYSTEMTIME st;			   //SystemTime
	static char t [257];			   //SystemTime (Time)
	GetLocalTime(&st);
	GetTimeFormat(LOCALE_USER_DEFAULT,TIME_NOSECONDS,&st,NULL,t,64);
	return (t);
}

//////////////////////////////////////////////////////////////////////

char *Get_LongDate ()
{
	static SYSTEMTIME st;			   //SystemTime
	static char d [257];			   //SystemTime (LONG Date)
	GetLocalTime(&st);
	GetDateFormat(LOCALE_USER_DEFAULT,DATE_LONGDATE,&st,NULL,d,64);
	return (d);
}

//////////////////////////////////////////////////////////////////////

char *Get_UserName ()
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char A[257];
	static DWORD b;
	if (++StrCnt==64) StrCnt = 0;
	b=256;
	GetUserName(A,&b);
	sprintf(StrFunction[StrCnt],"%s",A);
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

/*
6	Check for read and write permission
4	Check for read permission
2	Check for write permission
1	Execute (ignored)
0	Check for existence of file
*/

BOOL FAccess(char *FileName, short Mode)
{
	if(access(FileName, Mode) == 0)
		return 1;
	return 0;
}

//////////////////////////////////////////////////////////////////////

void Update_LastUsed(void)
{
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","User",Get_UserName());
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","Date",Get_LongDate());
	SetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\LastRun","Time",Get_Time());
}

//////////////////////////////////////////////////////////////////////

void FreeMemory(void)
{
	while(Package.FolderCount != 0)
	{
		free(Package.FolderNames[Package.FolderCount]);
		Package.FolderNames[Package.FolderCount] = '\0';
		Package.FolderCount--;
	}
	while(Package.FileCount != 0)
	{
		free(Package.FileNames[Package.FileCount]);
		Package.FileNames[Package.FileCount] = '\0';
		Package.FileCount--;
	}
}

///////////////////////////////////////////////////////////////////////

void Clear_ReadTemp(void)
{
	int LocalLoop = 0;
	while(LocalLoop < sizeof(ReadTemp))
	{
		ReadTemp[LocalLoop] = '\0';
		LocalLoop++;
	}
}

//////////////////////////////////////////////////////////////////////

char *LCase (char *S)
{
	static char StrFunction [64][257];
	static int StrCnt;
	static char Tmp [257];
	if(++StrCnt==64) StrCnt = 0;
	sprintf(Tmp,"%s",S);
	{
		sprintf (StrFunction[StrCnt],"%s",strlwr(Tmp));
	}
	return StrFunction[StrCnt];
}

//////////////////////////////////////////////////////////////////////

int CheckRegistered(void)
{
	DWORD Registration = 0;
	if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","Registered",Registration))
	{
		if(Registration == 1)
		{
			Registration = 0;
			if(GetDWORDValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Registry","128Code",Registration))
			{
				if(Registration == RegCode)Registration = 1;
				else Registration = 0;
			}
			else Registration = 0;
		}
		else Registration = 0;
	}
	else Registration = 0;

	if(Registration == 1) // If 128Gamma Is Registered
	{
		Registered = TRUE;
		ShortVersion = Reg_ShortVersion;
		MaxFiles = Reg_MaxFiles;
		MaxPackFileSize = Reg_MaxPackFileSize;
		MaxFileSize = Reg_MaxFileSize;
	}
	else{ // If 128Gamma Is NOT Registered
		Registered = FALSE;

		if(MessageBox(0,"This Is An Unregisterd Version Of 128Gamma.\r\n This message does not apear on registered versions. \r\n\r\n Would you like to buy the full version now?",TitleCaption,4+256+MB_ICONQUESTION + MB_SYSTEMMODAL) == IDYES)
		{
			char GammaPath[1024];
			unsigned long SizeOfGammaPath = sizeof(GammaPath);
			// Get 128Gamma Path
			if(GetStringValue(HKEY_CLASSES_ROOT,"*\\Shell\\128Gamma_Encryption\\AppInfo\\Path","Path",GammaPath,SizeOfGammaPath))
			{
				char Register_EXE[257];
				sprintf(Register_EXE,"%s\\%s",GammaPath,"Register.Exe");
				if(FAccess(Register_EXE,0)) // If Register_EXE Exist
				{
					ShellExecute(0,"open",Register_EXE,"","",SW_NORMAL);
					CleanUp(0,1);
					EndDialog(0,0);
					return 0;
				}
				else{ // If Register_EXE Does Not Exist
					MessageBox(0, "Registration Utility Not Found. \r\nPlease Reinstall 128Gamma." ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
				}
			}
			else // If Registry Error Or Key Not Found
			MessageBox(0, "Registry Key Not Found. \r\nPlease Reinstall 128Gamma." ,TitleCaption,0 + MB_ICONHAND + MB_SYSTEMMODAL);
		}
		ShortVersion = Unreg_ShortVersion;
		MaxFiles = Unreg_MaxFiles;
		MaxPackFileSize = Unreg_MaxPackFileSize;
		MaxFileSize = Unreg_MaxFileSize;
	}
	return 1;
}
////////////////////////////////////////////////////////////////////

