/*

- Main 128Gamma Encryption Algorithm

extern int IncodeMain(char *Input_File,char *Output_File)
extern int DecodeMain(char *Input_File, char *Output_File)

void ClearCodeVariables(void);
void AssembleByte(void);
void IncodeByte(void);

*/

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>

/////////////////////////////////////////////////////////////////////

unsigned short Byte_A, Byte_B, Byte_C, Byte_D, Byte_E;
unsigned short Byte_F, Byte_G, Byte_H5[5], Byte_I, Byte_J;
unsigned short Byte_K, Byte_L, Byte_M, Byte_N;

unsigned char Key[75];
short SingleChar;

char *CodedKey = "Key"; // The key to be used

void ClearCodeVariables(void);
void AssembleByte(void);
void IncodeByte(void);
void Error(char *);
extern char *IncodeMain(char *);
extern char *DecodeMain(char *);


//////////////////////////////////////////////////////////////////////

void Error(char *Message)
{
	printf("%s\n",Message);
	exit(0);
}

//////////////////////////////////////////////////////////////////////

extern char *IncodeMain(char *InputString)
{
	char DecodedString[1024];
	char *ReturnString;
	char CodingString[1024];

	sprintf(DecodedString,"%s",InputString);

	Byte_E = 0;
	Byte_G = 0;
	Byte_J = 0;

	strcpy(Key,CodedKey);

	int LocalLoop = 0;

	while( LocalLoop < strlen(DecodedString))
	{
		SingleChar = DecodedString[LocalLoop];

		AssembleByte();
		Byte_L = Byte_K >> 8;
		Byte_M = Byte_K &255;

		for (Byte_N = 0; Byte_N <= 9; Byte_N++)
		{
			Key[Byte_N] = Key[Byte_N] ^ SingleChar;
		}

		SingleChar = SingleChar ^ (Byte_L^Byte_M);

		CodingString[LocalLoop] = SingleChar;

		LocalLoop++;
	}

	ClearCodeVariables();

	ReturnString = CodingString;

	return ReturnString;
}

//////////////////////////////////////////////////////////////////////

extern char *DecodeMain(char *InputString)
{
	char DecodedString[1024];
	char *ReturnString;
	char CodingString[1024];

	sprintf(DecodedString,"%s",InputString);

	Byte_E = 0;
	Byte_G = 0;
	Byte_J = 0;

	strcpy(Key,CodedKey);

	int LocalLoop = 0;

	while( LocalLoop < strlen(DecodedString))
	{
		SingleChar = DecodedString[LocalLoop];

		AssembleByte();
		Byte_L = Byte_K >> 8;
		Byte_M = Byte_K &255;

		SingleChar = SingleChar ^ (Byte_L^Byte_M);

		for (Byte_N = 0; Byte_N <= 9; Byte_N++)
		{
			Key[Byte_N] = Key[Byte_N] ^ SingleChar;
		}

		CodingString[LocalLoop] = SingleChar;

		LocalLoop++;
	}

	ClearCodeVariables();

	ReturnString = CodingString;

	return ReturnString;
}

//////////////////////////////////////////////////////////////////////

void ClearCodeVariables(void)
{
	int LocalLoop = 0;
	for(LocalLoop = 0; LocalLoop < sizeof(Key); LocalLoop++)
	{
		Key[Byte_N] = 0;
	}

	Byte_A = 0;
	Byte_B = 0;
	Byte_C = 0;
	Byte_D = 0;
	Byte_E = 0;
	Byte_F = 0;
	Byte_G = 0;
	Byte_H5[0] = 0;
	Byte_H5[1] = 0;
	Byte_H5[2] = 0;
	Byte_H5[3]=0;
	Byte_H5[4] = 0;
	Byte_I = 0;
	Byte_J = 0;
	Byte_K = 0;
	Byte_L = 0;
	Byte_M = 0;
	Byte_N = 0;
	SingleChar = 0;
}

//////////////////////////////////////////////////////////////////////

void AssembleByte(void)
{
	Byte_H5[0] = ( Key[0] * 256 ) + Key[1];
	IncodeByte();
	Byte_K = Byte_I;
	Byte_H5[1] = Byte_H5[0] ^ ( (Key[2] * 256) + Key[3] );
	IncodeByte();
	Byte_K = Byte_K ^ Byte_I;
	Byte_H5[2] = Byte_H5[1] ^ ( (Key[4] * 256) + Key[5] );
	IncodeByte();
	Byte_K = Byte_K ^ Byte_I;
	Byte_H5[3] = Byte_H5[2] ^ ( (Key[6] * 256) + Key[7] );
	IncodeByte();
	Byte_K = Byte_K ^ Byte_I;
	Byte_H5[4] = Byte_H5[3] ^ ( (Key[8] * 256) + Key[9] );
	IncodeByte();
	Byte_K = Byte_K ^ Byte_I;
	Byte_J = 0;
}

//////////////////////////////////////////////////////////////////////

void IncodeByte(void)
{
	Byte_D = Byte_G + Byte_J;
	Byte_A = Byte_H5[Byte_J];
	Byte_C = 0x015a;
	Byte_B = 0x4e35;
	Byte_F = Byte_A;
	Byte_A = Byte_E;
	Byte_E = Byte_F;
	Byte_F = Byte_A;
	Byte_A = Byte_D;
	Byte_D = Byte_F;
	if (Byte_A != 0)
	{
		Byte_A = Byte_A * Byte_B;
	}
	Byte_F = Byte_A;
	Byte_A = Byte_C;
	Byte_C = Byte_F;
	if (Byte_A != 0)
	{
		Byte_A = Byte_A * Byte_E;
		Byte_C = Byte_A + Byte_C;
	}
	Byte_F = Byte_A;
	Byte_A = Byte_E;
	Byte_E = Byte_F;
	Byte_A = Byte_A * Byte_B;
	Byte_D = Byte_C + Byte_D;
	Byte_A = Byte_A + 1;
	Byte_G = Byte_D;
	Byte_H5[Byte_J] = Byte_A;
	Byte_I = Byte_A ^ Byte_D;
	Byte_J = Byte_J + 1;
}

//////////////////////////////////////////////////////////////////////

